using System;
using System.Runtime.InteropServices;
using Feynman;

public struct t_feynman_ecm
{
    public ushort caid;
    public int provid;
    public ushort sid;
    public IntPtr ecm;
    public int ecm_len;
    public int decrypt_status;
    public IntPtr dcw;
    public int dcw_len;
    public ushort session;
    public IntPtr client;
    public int card_id;
//             struct timeval time_added;
    public IntPtr next;
}

public struct t_feynman_emm
{
    public ushort caid;
    public int provid;
    public int sa;
    public int ua;
    public IntPtr emm;
    public int emm_len;
    public int card_id;
    public int emm_id;
//             struct timeval time_added;
    public IntPtr next;
}

namespace TestFeynman
{
    class TestFeynmanClient
    {

        private static int processDCW(int notUsed, ref t_feynman_ecm ecm)
        {
            byte[] dcw = new byte[0x10];

            Console.WriteLine("[ Test client ] Got dcw (via callback) for session " + ecm.session + " (status: " + ecm.decrypt_status + ")");
            Marshal.Copy(ecm.dcw, dcw, 0, ecm.dcw_len);

            Console.Write("[ Test client ] DCW: ");
            for(int i=0; i<ecm.dcw_len; i++)
            {
                Console.Write("{0:x} ", dcw[i]);
            }
            Console.Write("\n");

            return 1;
        }

        public static void Main(string[] args)
        {
            FeynmanClient client = new FeynmanClient("username", "password", "127.0.0.1", 12345, processDCW);

            if(client.isServerReady())
            {
                System.Threading.Thread.Sleep(2000);
                byte[] ecm = new byte[0x50];
                byte[] emm = new byte[0x50];
                byte[] dcw = new byte[0x10];

                int ecm_len = 0x50;
                int emm_len = 0x50;

                for(int i=0; i<ecm_len; i++)
                {
                    ecm[i] = 0x22;
                }

                for(int i=0; i<emm_len; i++)
                {
                    emm[i] = 0x33;
                }

                for(int i=0; i<0x10; i++)
                {
                    dcw[i] = 0x00;
                }

                if(client.sendECM(0x0b00, 0x00000000, 0x3001, ecm, ecm_len, dcw) == 1)
                {
                    Console.WriteLine("DCW: ");
                    for(int i=0; i<0x10; i++)
                    {
                        Console.Write("{0:x} ", dcw[i]);
                    }
                    Console.Write("\n");
                }

                client.sendEMM(0x0b00, 0x00000000, 0x123456, 0x12345678, emm, emm_len);
            }

            while(true)
            {
                System.Threading.Thread.Sleep(5000);
            }
        }
    }
}
